load("./benchmarks/groebner_basis/OperatorGB.py")


# defining the input
symbols = ['a','b','c','d','e','f','g','h','i','j']
KX = FreeAlgebra(QQ,symbols)
a,b,c,d,e,f,g,h,i,j = KX.gens()
ROL61 = [-a + a * c * a, -c + c * a * c, -a * c + 
 h * f, -c * a + f * h, -b + b * d * b, -d + 
 d * b * d, -b * d + i * g, -d * b + 
 g * i, -a * b + a * b * e * a * b, -e + 
 e * a * b * e, -a * b * e + 
 j * g * f, -e * a * b + 
 g * f * j, -b * d * f * a + 
 f * a * b * d, -b * g * c * a + 
 c * a * b * g, -f + 
 f * h * f, -h + h * f * h, 
a * c - h * f, 
c * a - f * h, -g + 
 g * i * g, -i + i * g * i, 
b * d - i * g, 
d * b - g * i, -g * f + 
 g * f * j * g * f, -j + 
 j * g * f * j, 
a * b * e - j * g * f, 
e * a * b - 
 g * f * j, -f * a * i * g + 
 i * g * f * a, 
b * g * f * h - f * h * b * g]
claim = e - d * c;

# using the Certify command, which enumerates a GB and computes a cofactor representation
# Certify uses some randomness, so we fix a seed to ensure reproducibility 
import random
random.seed(0)

Quiv = Quiver([(x,1,1) for x in KX.gens()])
proof = Certify(ROL61, claim, Quiv, 10)
print("Found cofactor representation of length %d" % sum(len(a) for a,_,_ in proof))