load("./benchmarks/groebner_basis/OperatorGB.py")


# defining the input
symbols = ['a','b','c','d','e','f','g','h','i','j']
KX = FreeAlgebra(QQ,symbols)
a,b,c,d,e,f,g,h,i,j = KX.gens()
ROL71 = [-a + a * c * a, -c + c * a * c, -a * c +  h * f,
-c * a + f * h, -b + b * d * b, -d +  d * b * d, -b * d + i * g,
-d * b + g * i, -a * b + a * b * e * a * b, -e + e * a * b * e,
-a * b * e + j * g * f, -e * a * b +  g * f * j,
-a * b * d + a * b * d * b * d * c * a * b * d,
-b * d * c + b * d * c * a * b * d * b * d *  c,
-a * b * d * b * d * c + h * i * g * i * g * f,
-b * d * c * a * b * d + i * g * f * h * i *  g,
-c * a * b + c * a * b * d * c * a * c * a * b,
-d * c * a + d * c * a * c * a * b * d * c * a,
-c * a * b * d * c * a + f * h * i * g * f *  h,
-d * c * a * c * a * b + g * f * h * f * h * i,
-f + f * h * f, -h + h * f * h, a * c - h * f, c * a - f * h,
-g + g * i * g, -i + i * g * i, b * d - i * g, d * b - g * i,
-g * f + g * f * j * g * f, -j + j * g * f * j, a * b * e - j * g * f,
e * a * b - g * f * j, -i * g * f + i * g * f * h * i * g * i * g * f,
-h * i * g + h * i * g * i * g * f * h *i * g,
a * b * d * b * d * c - h * i * g * i * g * f,
b * d * c * a * b * d - i * g * f * h * i * g,
-g * f * h + g * f * h * f * h * i * g * f * h,
-f * h * i + f * h * i * g * f * h * f * h * i,
c * a * b * d * c * a - f * h * i * g * f * h,
d * c * a * c * a * b - g * f * h * f * h * i]
claim = e - d * c;

# using the Certify command, which enumerates a GB and computes a cofactor representation
# Certify uses some randomness, so we fix a seed to ensure reproducibility 
import random
random.seed(0)

Quiv = Quiver([(x,1,1) for x in KX.gens()])
proof = Certify(ROL71, claim, Quiv, 10,MaxDeg=8)
print("Found cofactor representation of length %d" % sum(len(a) for a,_,_ in proof))

