from signature_gb import LabelledModule
load("ShortProofs.py")


# this is the used bound
bound = 17

# defining the input
symbols = ['a','A','b','B','c','C','d','D','e','E','f','F','g','G','h','H','i','I']
KX = FreeAlgebra(QQ,symbols)
a,A,b,B,c,C,d,D,e,E,f,F,g,G,h,H,i,I = KX.gens()
Hartwig51 =[
-a + a * b * a, -b + b * a * b, -a * b + 
 B * A, -b * a + A * B, -e + 
 e * f * e, -f + f * e * f, -e * f + 
 F * E, -f * e + E * F, -a * c * e + 
 a * c * e * g * a * c * e, -g + 
 g * a * c * e * g, -a * c * e * g + 
 G * E * C * A, -g * a * c * e + 
 E * C * A * G, -A * B * D * F * E + 
 A * a * b * a * c * e * f * i, -e * f * d * b * a * h + 
 e * f * e * E * C * A * B, -e * f * d * b * a + 
 e * f * d * b * a * b * a * c * e * f * e * f * d * b * a, -A + A * a * b, -B + 
 a * b * B, -E + 
 f * e * E, -F + 
 F * f * e, -E * C * A + 
 E * C * A * G * E * C * A, -G + 
 G * E * C * A * G, -e * f * d * b * a + 
 I * F * E * C * A * a * b * a, 
H * A * B * D * F * E - 
 b * a * c * e * f * e * E, -A * B * D * F * E + 
 A * B * D * F * f * e * E * C * A * a * b * B * D * F * E, -a * c * e + 
 a * c * e * f * d * b * a * c * e, -E * C * A + 
 E * C * A * B * D * F * E * C * A
]
claim = g - f * d * b
M = LabelledModule(Hartwig51, KX.gens())

# computing a sig. GB and an initial cofactor representation
print("Computing a sig. GB and a GB of the syzygy module...")
M.signature_GB(500,sig_bound=bound+2)
M.reconstruct_labelled_basis()
M.reconstruct_syzygies()
alpha = M.membership_test(claim)

print("Found initial cofactor representation (length: %d)" % len(alpha))

# compute short cofactor representation until bound starting from alpha 
proof = find_short_proof(alpha,bound,M)